--
-- Procediment que permet consultar les caracterstiques
-- demanades en l'apartat R4a de l'enunciat. Com a parmetres
--d'entrada hi ha el mes i l'any
--

create or replace procedure consulta_botigues(any_consulta INTEGER, mes INTEGER)
IS
hora_inici logbd.hora_inici%TYPE;
parametres logbd.param_procediment%TYPE;
CURSOR r_cursor_botigues

IS 
--Clcul del nmero total de productes venuts, el nombre de productes diferents venuts, el benefici total
select v.id_botiga AS idbotiga,sum(v.unitats) AS unitats_total,COUNT(DISTINCT v.id_producte) AS num_producte, sum(v.ben_net) AS ben_total,
-- Clcul del percentatge del benefici que aporta la botiga en relaci a la cadena
(sum(v.ben_net)*100/(SELECT SUM(ben_net) AS benefici FROM F_Venda v INNER JOIN D_Temps tt ON (v.id_temps=tt.id_temps)
where tt.any_temps=any_consulta AND tt.mes_any=mes)) AS percentatge,
--Clcul del benefici net dividit pel nombre d'empleats de la botiga
(sum(v.ben_net)/b.treballadors) AS rel_treballadors  
FROM F_VENDA v INNER JOIN D_Botiga b ON (v.id_botiga=b.id_botiga) INNER JOIN D_temps tt ON (v.id_temps=tt.id_temps)
  WHERE ( tt.any_temps=any_consulta AND tt.mes_any=mes) 
  GROUP BY v.id_botiga,b.treballadors ORDER BY ben_total DESC;
BEGIN
SELECT SYSDATE INTO hora_inici FROM DUAL;
parametres:=any_consulta || ';' || mes; 
FOR r_botigues IN r_cursor_botigues LOOP
--Mostrar resultats
  DBMS_OUTPUT.PUT_LINE('Id botiga:' || r_botigues.idbotiga ||' ' || 'unitats totals:' || r_botigues.unitats_total || ' ' ||
  'N productes:' || r_botigues.num_producte || ' ' || 'Benefici total:' || r_botigues.ben_total || ' ' ||
  'Percentatge:' || r_botigues.percentatge || ' ' || 'Relaci beneifici/treballador:' || r_botigues.rel_treballadors);
END LOOP;
--Registre de la crida
sp_i_logbd('consulta_botigues',parametres,hora_inici,sysdate,sqlerrm);
COMMIT;
EXCEPTION
	WHEN OTHERS THEN
		ROLLBACK;
		DBMS_OUTPUT.PUT_LINE(sqlerrm);
		sp_i_logbd('consulta_botigues',parametres,hora_inici,sysdate,sqlerrm);
END;