--
-- Procediment que permet consultar les caracterstiques
-- demanades en l'apartat R4c de l'enunciat. Com a parmetres
--d'entrada hi ha el mes i l'any
--
create or replace procedure consulta_dies(any_consulta INTEGER, mes INTEGER)
IS
idbotiga D_Botiga.id_botiga%TYPE;
ben_botiga INTEGER;
codi_ean D_Producte.id_codi_ean%TYPE;
unitats_total INTEGER;
hora_inici logbd.hora_inici%TYPE;
parametres logbd.param_procediment%TYPE;
CURSOR r_cursor_dies
IS
SELECT temps.dia_mes AS diames,
-- Benefici net obtingut per tota la cadena en un dia concret
sum(v.ben_net) AS ben_total
FROM D_Temps temps INNER JOIN F_VENDA v ON (v.id_temps=temps.id_temps) 
  WHERE ( temps.any_temps=any_consulta AND temps.mes_any=mes ) 
  group by temps.dia_mes
       ORDER BY temps.dia_mes ASC;
BEGIN
SELECT SYSDATE INTO hora_inici FROM DUAL;
parametres:=any_consulta || ';' || mes; 
FOR r_dies IN r_cursor_dies LOOP
-- Botiga amb ms benefici i el benefici total
select id_botiga,bentotal into idbotiga,ben_botiga from((select  temps.dia_mes,v.id_botiga,sum(ben_net) As bentotal FROM D_Temps temps
INNER JOIN F_Venda v ON (temps.id_temps=v.id_temps) where temps.any_temps=any_consulta AND temps.mes_any=mes
group by temps.dia_mes, v.id_botiga)aa ) 
where aa.dia_mes=r_dies.diames AND bentotal=(Select max(aa.bentotal) from ((select  temps.dia_mes,v.id_botiga,sum(ben_net) As bentotal FROM D_Temps temps
INNER JOIN F_Venda v ON (temps.id_temps=v.id_temps)  where temps.any_temps=any_consulta AND temps.mes_any=mes group by temps.dia_mes, v.id_botiga)aa ) 
where aa.dia_mes=r_dies.diames) ;
--Producte amb ms vendes i la quantitat de productes venuts
select id_codi_ean,unitats_total into codi_ean,unitats_total from(
(select  temps.dia_mes,pp.id_codi_ean,sum(unitats) As unitats_total FROM( D_Temps temps
INNER JOIN F_Venda v ON (temps.id_temps=v.id_temps)INNER JOIN D_Producte pp ON(v.id_producte=pp.id_producte)
)where temps.any_temps=any_consulta AND temps.mes_any=mes
group by temps.dia_mes, pp.id_codi_ean)aa ) 
where aa.dia_mes=r_dies.diames AND unitats_total =
(Select max(aa.unitats_total) from( (select  temps.dia_mes,pp.id_codi_ean,sum(unitats) As unitats_total FROM( D_Temps temps
INNER JOIN F_Venda v ON (temps.id_temps=v.id_temps)INNER JOIN D_Producte pp ON(v.id_producte=pp.id_producte))
where temps.any_temps=any_consulta AND temps.mes_any=mes group by temps.dia_mes, pp.id_codi_ean)aa ) 
where aa.dia_mes=r_dies.diames);
--Mostrar resultat 
DBMS_OUTPUT.PUT_LINE('Dia del mes:' || r_dies.diames ||' ' || 'Benefici total:' || r_dies.ben_total || ' ' ||
' Producte ms venut:' || codi_ean || ' ' ||  'N productes:' || unitats_total || ' ' || 
  'Id_botiga:' ||idbotiga|| ' ' || 'Benefici botiga:' || ben_botiga);
END LOOP;
--Registre de la crida
sp_i_logbd('consulta_dies',parametres,hora_inici,sysdate,sqlerrm);
  COMMIT;
EXCEPTION
	WHEN OTHERS THEN
		ROLLBACK;
		DBMS_OUTPUT.PUT_LINE(sqlerrm);
		sp_i_logbd('consulta_dies',parametres,hora_inici,sysdate,sqlerrm);
END;