--
--Consulta del registre de la taula estadstica segons l'any introduit com
--a parmetre d'entrada
--
create or replace PROCEDURE consulta_estadistica(p_any INTEGER)
IS
	hora_inici logbd.hora_inici%TYPE;
  p_id_estadistica Estadistica.id_estadistica%TYPE;
  p_any_estudi Estadistica.any_estudi%TYPE;
  p_ben_cadena Estadistica.ben_cadena%TYPE;
  p_id_botiga Estadistica.id_botiga%TYPE;
  p_benef_botiga Estadistica.benef_botiga%TYPE;
  p_id_codi_ean Estadistica.id_codi_ean%TYPE;
  p_un_prod Estadistica.un_prod%TYPE;
  p_hora_dia_mes Estadistica.hora_dia_mes%TYPE;
  p_num_prod_mes Estadistica.num_prod_mes%TYPE;
  p_hora_dia_menys Estadistica.hora_dia_menys%TYPE;
  p_num_prod_menys Estadistica.num_prod_menys%TYPE;
  p_dia_mes Estadistica.dia_mes%TYPE;
  p_num_dia_mes Estadistica.num_dia_mes%TYPE;
  p_dia_menys Estadistica.dia_menys%TYPE;
  p_num_dia_menys Estadistica.num_dia_menys%TYPE;
  p_ciutat Estadistica.ciutat%TYPE;
  p_ben_ciutat Estadistica.ben_ciutat%TYPE;
  p_percentatge Estadistica.percentatge%TYPE;
  
BEGIN
	SELECT SYSDATE INTO hora_inici FROM DUAL;
	SELECT * INTO p_id_estadistica, p_any_estudi,p_ben_cadena,p_id_botiga,
  p_benef_botiga, p_id_codi_ean,p_un_prod,p_hora_dia_mes,p_num_prod_mes,
  p_hora_dia_menys,p_num_prod_menys,p_dia_mes,p_num_dia_mes,p_dia_menys,
  p_num_dia_menys,p_ciutat,p_ben_ciutat,p_percentatge 
  FROM Estadistica WHERE any_estudi=p_any;
  DBMS_OUTPUT.PUT_LINE('Any estudi:' || p_any_estudi|| ' ' || 'Benefici cadena:' || p_ben_cadena || ' ' ||
  'Botiga ms vendes:' ||p_id_botiga ||' ' || 'Benefici botiga:' || p_benef_botiga || ' '||
  'Producte ms venut:' || p_id_codi_ean || ' ' || 'Unitats venudes:'|| p_un_prod || ' ' ||
  'Hora ms vendes:' ||p_hora_dia_mes || ' ' ||
  'Quantitat productes:' || p_num_prod_mes || ' ' || 'Hora menys vendes:' ||p_hora_dia_menys || ' ' ||
  'Quantitat productes:' || p_num_prod_menys || ' ' || 'Dia ms vendes:' || p_dia_mes || ' ' ||
  'Quantitat productes:' || p_num_dia_mes || ' ' || 'Dia menys vendes:' || p_dia_menys || ' ' ||
  'Quantitat productes:' || p_num_dia_menys || ' ' || ' Ciutat ms benefici:' || p_ciutat || ' ' ||
  'Benefici ciutat:' || p_ben_ciutat || ' ' || 'Percentatge benefici virtual:' || p_percentatge);
	sp_i_logbd('consulta_estadistica',p_any,hora_inici,sysdate,sqlerrm);
  
COMMIT;
EXCEPTION
	WHEN NO_DATA_FOUND THEN
		DBMS_OUTPUT.PUT_LINE('Registre no trobat');
		sp_i_logbd('consulta_estadistica',p_any,hora_inici,sysdate,sqlerrm);
	WHEN OTHERS THEN
		ROLLBACK;
	DBMS_OUTPUT.PUT_LINE(sqlerrm);
	sp_i_logbd('consulta_estadistica',p_any,hora_inici,sysdate,sqlerrm);
END;