--
-- Procediment que permet consultar les caracterstiques
-- demanades en l'apartat R4b de l'enunciat. Com a parmetres
--d'entrada hi ha el mes i l'any
--
create or replace procedure consulta_productes(any_consulta INTEGER, mes INTEGER)
IS
unitats_botiga INTEGER;
hora_inici logbd.hora_inici%TYPE;
parametres logbd.param_procediment%TYPE;
idbotiga D_Botiga.id_botiga%TYPE;
CURSOR r_cursor_productes
IS 
--Identificador del producte, nom del producte, nmero d'unitats venudes i benefici net obtingut
SELECT p.id_codi_ean AS codi_ean,
p.descripcio AS descripcio,
sum(v.unitats) AS unitats_total, 
SUM(v.ben_net) AS ben_total 
FROM F_VENDA v INNER JOIN D_Producte p ON (v.id_producte=p.id_producte) INNER JOIN D_Temps tt ON (v.id_temps=tt.id_temps)
  WHERE ( tt.any_temps=any_consulta AND tt.mes_any=mes ) 
  group by p.id_codi_ean, p.descripcio
       ORDER BY ben_total DESC;

BEGIN
SELECT SYSDATE INTO hora_inici FROM DUAL;
parametres:=any_consulta || ';' || mes; 
FOR r_productes IN r_cursor_productes LOOP
--Botiga que ha venut ms unitats i el nombre d'unitats venudes per a cada producte
select id_botiga,unitats_total into idbotiga,unitats_botiga from((select  v.id_producte,v.id_botiga,sum(unitats) As unitats_total 
FROM F_Venda v INNER JOIN D_Temps tt ON (v.id_temps=tt.id_temps)
  WHERE ( tt.any_temps=any_consulta AND tt.mes_any=mes)
group by v.id_producte, v.id_botiga)aa inner join d_producte pp on (aa.id_producte=pp.id_producte))
where pp.id_codi_ean=r_productes.codi_ean AND unitats_total =
(Select max(aa.unitats_total) from ((select  v.id_producte,v.id_botiga,sum(unitats) As unitats_total 
FROM F_Venda v   INNER JOIN D_Temps tt ON (v.id_temps=tt.id_temps)
WHERE ( tt.any_temps=any_consulta AND tt.mes_any=mes)
group by v.id_producte, v.id_botiga)aa inner join d_producte pp on (aa.id_producte=pp.id_producte))
where pp.id_codi_ean=r_productes.codi_ean);
  DBMS_OUTPUT.PUT_LINE('Codi EAN:' || r_productes.codi_ean ||' ' || 'Descripci:' || r_productes.descripcio || ' ' ||
  'N productes:' || r_productes.unitats_total || ' ' || 'Benefici total:' || r_productes.ben_total || ' ' ||
  'Id_botiga:' ||idbotiga|| ' ' || 'Unitats venudes botiga:' || unitats_botiga);
END LOOP;
-- registra de la crida
sp_i_logbd('consulta_productes',parametres,hora_inici,sysdate,sqlerrm);
  COMMIT;
EXCEPTION
	WHEN OTHERS THEN
		ROLLBACK;
		DBMS_OUTPUT.PUT_LINE(sqlerrm);
		sp_i_logbd('consulta_productes',parametres,hora_inici,sysdate,sqlerrm);
END;